"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Node in a double-linked list.
 */
var CacheNode = /** @class */ (function () {
    function CacheNode(key, value) {
        this.key = key;
        this.value = value;
        this.previous = this;
        this.next = this;
    }
    CacheNode.prototype.remove = function () {
        this.previous.next = this.next;
        this.next.previous = this.previous;
        this.next = this.previous = this;
    };
    CacheNode.prototype.append = function (head) {
        var tail = head.previous;
        head.previous = this;
        tail.next = this;
        this.next = head;
        this.previous = tail;
    };
    CacheNode.prototype.move = function (head) {
        this.remove();
        this.append(head);
    };
    return CacheNode;
}());
exports.CacheNode = CacheNode;
//# sourceMappingURL=cache-node.js.map