"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var wrapped_1 = require("../wrapped");
var DATA = Symbol('loadingData');
/**
 * Extension to another cache that will load items if they are not cached.
 */
var DefaultLoadingCache = /** @class */ (function (_super) {
    __extends(DefaultLoadingCache, _super);
    function DefaultLoadingCache(options) {
        var _this = _super.call(this, options.parent, options.removalListener || null) || this;
        _this[DATA] = {
            promises: new Map(),
            loader: options.loader || null
        };
        return _this;
    }
    DefaultLoadingCache.prototype.get = function (key, loader) {
        var _this = this;
        if (this.has(key)) {
            return Promise.resolve(this.getIfPresent(key));
        }
        var data = this[DATA];
        // First check if we are already loading this value
        var promise = data.promises.get(key);
        if (promise)
            return promise;
        // Create the initial promise if we are not already loading
        if (typeof loader !== 'undefined') {
            if (typeof loader !== 'function') {
                throw new Error('If loader is used it must be a function that returns a value or a Promise');
            }
            promise = Promise.resolve(loader(key));
        }
        else if (data.loader) {
            promise = Promise.resolve(data.loader(key));
        }
        if (!promise) {
            throw new Error('No way to load data for key: ' + key);
        }
        // Enhance with handler that will remove promise and set value if success
        var resolve = function () { return data.promises.delete(key); };
        promise = promise.then(function (result) {
            _this.set(key, result);
            resolve();
            return result;
        }).catch(function (err) {
            resolve();
            throw err;
        });
        data.promises.set(key, promise);
        return promise;
    };
    return DefaultLoadingCache;
}(wrapped_1.WrappedCache));
exports.DefaultLoadingCache = DefaultLoadingCache;
//# sourceMappingURL=index.js.map