"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var wrapped_1 = require("../wrapped");
var METRICS = Symbol('metrics');
/**
 * Extension to a cache that tracks metrics about the size and hit rate of
 * a cache.
 */
var MetricsCache = /** @class */ (function (_super) {
    __extends(MetricsCache, _super);
    function MetricsCache(options) {
        var _this = _super.call(this, options.parent, options.removalListener || null) || this;
        _this[METRICS] = {
            hits: 0,
            misses: 0,
            get hitRate() {
                var total = this.hits + this.misses;
                if (total === 0)
                    return 1.0;
                return this.hits / total;
            }
        };
        return _this;
    }
    Object.defineProperty(MetricsCache.prototype, "metrics", {
        get: function () {
            return this[METRICS];
        },
        enumerable: true,
        configurable: true
    });
    MetricsCache.prototype.getIfPresent = function (key) {
        var result = _super.prototype.getIfPresent.call(this, key);
        if (result === null) {
            this[METRICS].misses++;
        }
        else {
            this[METRICS].hits++;
        }
        return result;
    };
    return MetricsCache;
}(wrapped_1.WrappedCache));
exports.MetricsCache = MetricsCache;
//# sourceMappingURL=index.js.map