"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var abstract_1 = require("./abstract");
var symbols_1 = require("./symbols");
var PARENT = Symbol('parent');
var REMOVAL_LISTENER = Symbol('removalListener');
/**
 * Wrapper for another cache, used to extend that cache with new behavior,
 * like for loading things or collecting metrics.
 */
var WrappedCache = /** @class */ (function (_super) {
    __extends(WrappedCache, _super);
    function WrappedCache(parent, removalListener) {
        var _this = _super.call(this) || this;
        _this[PARENT] = parent;
        _this[REMOVAL_LISTENER] = removalListener;
        // Custom onRemove handler for the parent cache
        _this[PARENT][symbols_1.ON_REMOVE] = _this[symbols_1.TRIGGER_REMOVE].bind(_this);
        return _this;
    }
    Object.defineProperty(WrappedCache.prototype, "maxSize", {
        get: function () {
            return this[PARENT].maxSize;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WrappedCache.prototype, "size", {
        get: function () {
            return this[PARENT].size;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WrappedCache.prototype, "weightedSize", {
        get: function () {
            return this[PARENT].weightedSize;
        },
        enumerable: true,
        configurable: true
    });
    WrappedCache.prototype.set = function (key, value) {
        return this[PARENT].set(key, value);
    };
    WrappedCache.prototype.getIfPresent = function (key) {
        return this[PARENT].getIfPresent(key);
    };
    WrappedCache.prototype.peek = function (key) {
        return this[PARENT].peek(key);
    };
    WrappedCache.prototype.has = function (key) {
        return this[PARENT].has(key);
    };
    WrappedCache.prototype.delete = function (key) {
        return this[PARENT].delete(key);
    };
    WrappedCache.prototype.clear = function () {
        return this[PARENT].clear();
    };
    WrappedCache.prototype.keys = function () {
        return this[PARENT].keys();
    };
    WrappedCache.prototype.cleanUp = function () {
        return this[PARENT].cleanUp();
    };
    Object.defineProperty(WrappedCache.prototype, "metrics", {
        get: function () {
            return this[PARENT].metrics;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WrappedCache.prototype, symbols_1.ON_EVICT, {
        get: function () {
            return this[PARENT][symbols_1.ON_EVICT];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WrappedCache.prototype, symbols_1.ON_EVICT, {
        set: function (listener) {
            this[PARENT][symbols_1.ON_EVICT] = listener;
        },
        enumerable: true,
        configurable: true
    });
    WrappedCache.prototype[symbols_1.TRIGGER_REMOVE] = function (key, value, reason) {
        // Trigger any extended remove listeners
        var onRemove = this[symbols_1.ON_REMOVE];
        if (onRemove) {
            onRemove(key, value, reason);
        }
        // Trigger the removal listener
        var listener = this[REMOVAL_LISTENER];
        if (listener) {
            listener(key, value, reason);
        }
    };
    return WrappedCache;
}(abstract_1.AbstractCache));
exports.WrappedCache = WrappedCache;
//# sourceMappingURL=wrapped.js.map