import { KeyType } from '../key-type';
import { Cache } from '../cache';
import { CommonCacheOptions } from '../common-options';
import { WrappedCache } from '../wrapped';
import { LoadingCache } from './loading-cache';
import { Loader } from './loader';
declare const DATA: unique symbol;
/**
 * Options available for a loading cache.
 */
export interface LoadingCacheOptions<K extends KeyType, V> extends CommonCacheOptions<K, V> {
    loader?: Loader<K, V> | undefined | null;
    parent: Cache<K, V>;
}
/**
 * Extension to another cache that will load items if they are not cached.
 */
export declare class DefaultLoadingCache<K extends KeyType, V> extends WrappedCache<K, V> implements LoadingCache<K, V> {
    private [DATA];
    constructor(options: LoadingCacheOptions<K, V>);
    get(key: K, loader?: Loader<K, V>): Promise<V>;
}
export {};
