import { KeyType } from '../key-type';
import { Cache } from '../cache';
import { WrappedCache } from '../wrapped';
import { Metrics } from './metrics';
import { CommonCacheOptions } from '../common-options';
declare const METRICS: unique symbol;
/**
 * Options available for a metrics cache.
 */
export interface MetricsCacheOptions<K extends KeyType, V> extends CommonCacheOptions<K, V> {
    parent: Cache<K, V>;
}
/**
 * Extension to a cache that tracks metrics about the size and hit rate of
 * a cache.
 */
export declare class MetricsCache<K extends KeyType, V> extends WrappedCache<K, V> {
    private [METRICS];
    constructor(options: MetricsCacheOptions<K, V>);
    get metrics(): Metrics;
    getIfPresent(key: K): V | null;
}
export {};
